﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Security.Cryptography; // MD5

namespace AFMV4
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void inputBox_TextChanged(object sender, EventArgs e)
        {
            computeMD5();

            if (inputBox.Text.Length == 9)
            {
                if (checkafm(inputBox.Text))
                {
                    pictureBox1.Image = Properties.Resources.correct;
                }
                else
                {
                    pictureBox1.Image = Properties.Resources.wrong;
                }
            }
            else
            {
                pictureBox1.Image = null;
            }
        }

        private Boolean checkafm(String s)
        {
            int sum = 0;
            int weight = 2;
            for (int j = 7; j >= 0; j--)
            {
                sum += int.Parse(s[j].ToString()) * weight;
                weight *= 2;
            }
            int checksum = ((sum % 11) % 10);
            return checksum == int.Parse(s[8].ToString());
        }

        private void computeMD5()
        {
            MD5 md5 = System.Security.Cryptography.MD5.Create();
            byte[] inputBytes = Encoding.Unicode.GetBytes(inputBox.Text);
            byte[] md5hash = md5.ComputeHash(inputBytes);
            hashBox.Text = Convert.ToBase64String(md5hash);
            //hashBox.Text = BitConverter.ToString(md5hash);
        }

        private void inputBox_KeyPress(object sender, KeyPressEventArgs e)
        {
            char ch = e.KeyChar;
            if (!char.IsDigit(ch) && ch !=8  && ch !=127)
            {
                e.Handled = true;
            }
        }
    }
}
